using System;
using System.Text;
using System.Collections.Generic;
using Shards;
using Franca;
using Franca.Gui;

namespace Gui {
    public class WorldPreviewWindow : RectWidget {
        public WorldPreviewImage Preview { get; set; }
        public Label Message { get; set; }
        public Label @Label1 { get; set; }


        public WorldPreviewWindow(IWidget parent)
            : base(parent) {
            Preview = new WorldPreviewImage(this);
            Message = new Label(this);
            @Label1 = new Label(this);
        }

        public override void Layout(IGuiContext context) {
            Layout((Shards.Container)context);
        }

        public virtual void Layout(Shards.Container context) {
            base.Layout(context);
            this.X = Preview.Zoom > 2 ? 0 : 16;
            this.Y = Preview.Zoom > 2 ? 0 : 16;
            this.Width = Preview.Zoom > 2 ? context.GraphicsDevice.BackbufferWidth : 512 + 32;
            this.Height = Preview.Zoom > 2 ? context.GraphicsDevice.BackbufferHeight : Message.Bottom + 16;
            this.HasID = true;
            this.Color = new Color(-2894893);
            Preview.Layout(context);
            Preview.X = 16;
            Preview.Y = 16;
            Preview.Width = Preview.Zoom > 2 ? Preview.Parent.Width - 32 : 512;
            Preview.Height = Preview.Zoom > 2 ? Preview.Parent.Height - Message.Height - 48 : 512;
            Preview.PostLayout(context);
            Message.Layout(context);
            Message.Text = Calc.Floor(context.WorldPreview.Progress.Progress * 100) + "%: " + context.WorldPreview.Progress.Message;
            Message.Color = new Color(-16777216);
            Message.X = Preview.X * 1.0;
            Message.Y = Preview.Zoom > 2 ? Message.Parent.Height - 16 - Message.Height : Preview.Bottom + 16;
            Message.PostLayout(context);
            @Label1.Layout(context);
            @Label1.Text = "Generate";
            @Label1.Color = @Label1.IsMouseOver ? Color.Gray : Color.Black;
            @Label1.Right = this.Width - 16;
            @Label1.Y = Message.Y * 1.0;
            @Label1.OnClick = (e) => { Game.Context.Generate(); Preview.Zoomed = false; };
            @Label1.PostLayout(context);
            base.PostLayout(context);
        }

        public override void Render(IGuiContext context) {
            Render((Shards.Container)context);
        }

        public virtual void Render(Shards.Container context) {
            base.ConfirmZone(context);
            base.BeginRender(context);
            base.Render(context);
            Preview.ConfirmZone(context);
            Preview.BeginRender(context);
            Preview.Render(context);
            Preview.PostRender(context);
            Message.ConfirmZone(context);
            Message.BeginRender(context);
            Message.Render(context);
            Message.PostRender(context);
            @Label1.ConfirmZone(context);
            @Label1.BeginRender(context);
            @Label1.Render(context);
            @Label1.PostRender(context);
            base.PostRender(context);
        }
    }
}